package service

import (
	"cicv-data-closedloop/aarch64/pji/common/config"
	"cicv-data-closedloop/common/config/c_log"
	"cicv-data-closedloop/common/util"
	"os"
)

func CollectMap() {

	// rosbag record -O /root/cicv-data-closedloop/map_data.bag -l 1 /map
	localMapBagPath := "/root/cicv-data-closedloop/map.bag"
	ossMapBagObjectKey := config.LocalConfig.OssBasePrefix + config.LocalConfig.EquipmentNo + "/map.bag"

	var command []string
	command = append(command, "record")
	command = append(command, "-O "+localMapBagPath)
	command = append(command, "-l 1")
	_, err := util.ExecuteWithEnvAndDirAsync(config.RosbagEnvs, config.CloudConfig.BagDataDir, config.RosbagPath, command...)
	if err != nil {
		c_log.GlobalLogger.Error("程序异常退出。采集地图", command, "出错：", err)
		os.Exit(-1)
	}
	config.OssMutex.Lock()
	err = config.OssBucket.PutObjectFromFile(ossMapBagObjectKey, localMapBagPath)
	config.OssMutex.Unlock()
	if err != nil {
		c_log.GlobalLogger.Error("程序异常退出。上传地图包", ossMapBagObjectKey, "->", ossMapBagObjectKey, "出错：", err)
		os.Exit(-1)
	}
}
